
!-------------------------------------------------------------------------------
!> module TRACER
!!
!! @par Description
!!          Tracer module
!!
!! @author Team SCALE
!!
!! @par History
!! @li      2013-12-04 (S.Nishizawa)   [new]
!!
!<
!-------------------------------------------------------------------------------
! Warning: This file was generated from common/scale_tracer.F90.erb.
!          Do not edit this file.
!-------------------------------------------------------------------------------
module scale_tracer
  !-----------------------------------------------------------------------------
  !
  !++ used modules
  !
  use scale_precision
  use scale_stdio
  !-----------------------------------------------------------------------------
  implicit none
  private
  !-----------------------------------------------------------------------------
  !
  !++ Public procedure
  !
  !-----------------------------------------------------------------------------
  !
  !++ Public parameters & variables
  !

#ifdef TRACER
#define EXTM(name) inc_tracer_ ## name ## .h
#define NAME(name) EXTM(name)
#define XSTR(s) # s
#define STR(s) XSTR(s)
  include STR(NAME(TRACER))
#else
  integer, public :: QA

  integer, public :: QA_MP
  integer, public :: I_QV
  integer, public :: I_QC
  integer, public :: I_QR
  integer, public :: I_QI
  integer, public :: I_QS
  integer, public :: I_QG
  integer, public :: I_NC
  integer, public :: I_NR
  integer, public :: I_NI
  integer, public :: I_NS
  integer, public :: I_NG

  integer, public :: QQA ! mass tracer (water)
  integer, public :: QQS ! start index for mass tracer
  integer, public :: QQE ! end   index for mass tracer

  integer, public :: QWS ! start index for water tracer
  integer, public :: QWE ! end   index for water tracer
  integer, public :: QIS ! start index for ice tracer
  integer, public :: QIE ! end   index for ice tracer

  integer, public :: QA_AE   ! number of tracer for aerosol
  integer, public :: AE_CTG  ! category number of aerosol
  integer, public :: GAS_CTG ! category number of gas
  integer, public :: N_ATR   ! number of attribute
  integer, public, allocatable :: NKAP(:)
  integer, public, allocatable :: NSIZ(:)
  integer, public :: IC_MIX
  integer, public :: IC_SEA
  integer, public :: IC_DUS
  integer, public :: IG_H2SO4
  integer, public :: IG_CGAS
  integer, public :: QAES ! start index for aerosol tracer
  integer, public :: QAEE ! end   index for aerosol tracer

  character(len=H_SHORT), public, allocatable :: AQ_NAME(:)
  character(len=H_SHORT), public, allocatable :: AQ_MP_NAME(:)
  character(len=H_SHORT), public, allocatable :: AQ_AE_NAME(:)
  character(len=H_MID)  , public, allocatable :: AQ_DESC(:)
  character(len=H_MID)  , public, allocatable :: AQ_MP_DESC(:)
  character(len=H_MID)  , public, allocatable :: AQ_AE_DESC(:)
  character(len=H_SHORT), public, allocatable :: AQ_UNIT(:)
  character(len=H_SHORT), public, allocatable :: AQ_MP_UNIT(:)
  character(len=H_SHORT), public, allocatable :: AQ_AE_UNIT(:)

  !-----------------------------------------------------------------------------
  !
  !++ tracer index & relationship (MP_dry+AE_dummy+RD_mstrnx)
  !
  !-----------------------------------------------------------------------------

  integer, public :: MP_QA ! number of hydrometeor tracer
  integer, public, allocatable :: I_MP2ALL(:)

  integer, public, allocatable :: I_MP2RD(:)

  integer, public :: AE_QA ! number of aerosol tracer
  integer, public :: I_ae_dummy
  integer, public, allocatable :: I_AE2ALL(:)

  integer, public, allocatable :: I_AE2RD(:)

  character(len=H_SHORT), public :: TRACER_TYPE = 'DRY'
  character(len=H_SHORT), public :: AETRACER_TYPE = 'NONE'
#endif
  !-----------------------------------------------------------------------------
  !
  !++ Private procedure
  !
  public :: TRACER_setup

  !-----------------------------------------------------------------------------
  !
  !++ Private parameters & variables
  !
  !-----------------------------------------------------------------------------
contains
  !-----------------------------------------------------------------------------
  !> Setup
  subroutine TRACER_setup
#ifdef TRACER
#define EXTM2(name) scale_tracer_ ## name
#define _MODNAME(name) EXTM2(name)
#define EXTM3(name) tracer_ ## name ## _setup
#define _SETUP(name) EXTM3(name)
  use _MODNAME(TRACER), only: &
    _SETUP(TRACER)
#else
  use scale_process, only: &
    PRC_MPIstop
  use scale_tracer_dry, only: &
    QA_MP_dry => QA_MP, &
    I_QV_dry => I_QV, &
    I_QC_dry => I_QC, &
    I_QR_dry => I_QR, &
    I_QI_dry => I_QI, &
    I_QS_dry => I_QS, &
    I_QG_dry => I_QG, &
    I_NC_dry => I_NC, &
    I_NR_dry => I_NR, &
    I_NI_dry => I_NI, &
    I_NS_dry => I_NS, &
    I_NG_dry => I_NG, &
    QQA_dry => QQA, &
    QQS_dry => QQS, &
    QQE_dry => QQE, &
    QWS_dry => QWS, &
    QWE_dry => QWE, &
    QIS_dry => QIS, &
    QIE_dry => QIE, &
    MP_QA_dry => MP_QA, &
    AQ_MP_NAME_dry => AQ_MP_NAME, &
    AQ_MP_DESC_dry => AQ_MP_DESC, &
    AQ_MP_UNIT_dry => AQ_MP_UNIT, &
    I_MP2ALL_dry => I_MP2ALL, &
    I_MP2RD_dry => I_MP2RD, &
    TRACER_dry_setup
  use scale_tracer_kessler, only: &
    QA_MP_kessler => QA_MP, &
    I_QV_kessler => I_QV, &
    I_QC_kessler => I_QC, &
    I_QR_kessler => I_QR, &
    I_QI_kessler => I_QI, &
    I_QS_kessler => I_QS, &
    I_QG_kessler => I_QG, &
    I_NC_kessler => I_NC, &
    I_NR_kessler => I_NR, &
    I_NI_kessler => I_NI, &
    I_NS_kessler => I_NS, &
    I_NG_kessler => I_NG, &
    QQA_kessler => QQA, &
    QQS_kessler => QQS, &
    QQE_kessler => QQE, &
    QWS_kessler => QWS, &
    QWE_kessler => QWE, &
    QIS_kessler => QIS, &
    QIE_kessler => QIE, &
    MP_QA_kessler => MP_QA, &
    AQ_MP_NAME_kessler => AQ_MP_NAME, &
    AQ_MP_DESC_kessler => AQ_MP_DESC, &
    AQ_MP_UNIT_kessler => AQ_MP_UNIT, &
    I_MP2ALL_kessler => I_MP2ALL, &
    I_MP2RD_kessler => I_MP2RD, &
    TRACER_kessler_setup
  use scale_tracer_tomita08, only: &
    QA_MP_tomita08 => QA_MP, &
    I_QV_tomita08 => I_QV, &
    I_QC_tomita08 => I_QC, &
    I_QR_tomita08 => I_QR, &
    I_QI_tomita08 => I_QI, &
    I_QS_tomita08 => I_QS, &
    I_QG_tomita08 => I_QG, &
    I_NC_tomita08 => I_NC, &
    I_NR_tomita08 => I_NR, &
    I_NI_tomita08 => I_NI, &
    I_NS_tomita08 => I_NS, &
    I_NG_tomita08 => I_NG, &
    QQA_tomita08 => QQA, &
    QQS_tomita08 => QQS, &
    QQE_tomita08 => QQE, &
    QWS_tomita08 => QWS, &
    QWE_tomita08 => QWE, &
    QIS_tomita08 => QIS, &
    QIE_tomita08 => QIE, &
    MP_QA_tomita08 => MP_QA, &
    AQ_MP_NAME_tomita08 => AQ_MP_NAME, &
    AQ_MP_DESC_tomita08 => AQ_MP_DESC, &
    AQ_MP_UNIT_tomita08 => AQ_MP_UNIT, &
    I_MP2ALL_tomita08 => I_MP2ALL, &
    I_MP2RD_tomita08 => I_MP2RD, &
    TRACER_tomita08_setup
  use scale_tracer_sn14, only: &
    QA_MP_sn14 => QA_MP, &
    I_QV_sn14 => I_QV, &
    I_QC_sn14 => I_QC, &
    I_QR_sn14 => I_QR, &
    I_QI_sn14 => I_QI, &
    I_QS_sn14 => I_QS, &
    I_QG_sn14 => I_QG, &
    I_NC_sn14 => I_NC, &
    I_NR_sn14 => I_NR, &
    I_NI_sn14 => I_NI, &
    I_NS_sn14 => I_NS, &
    I_NG_sn14 => I_NG, &
    QQA_sn14 => QQA, &
    QQS_sn14 => QQS, &
    QQE_sn14 => QQE, &
    QWS_sn14 => QWS, &
    QWE_sn14 => QWE, &
    QIS_sn14 => QIS, &
    QIE_sn14 => QIE, &
    MP_QA_sn14 => MP_QA, &
    AQ_MP_NAME_sn14 => AQ_MP_NAME, &
    AQ_MP_DESC_sn14 => AQ_MP_DESC, &
    AQ_MP_UNIT_sn14 => AQ_MP_UNIT, &
    I_MP2ALL_sn14 => I_MP2ALL, &
    I_MP2RD_sn14 => I_MP2RD, &
    TRACER_sn14_setup
  use scale_tracer_suzuki10, only: &
    QA_MP_suzuki10 => QA_MP, &
    I_QV_suzuki10 => I_QV, &
    I_QC_suzuki10 => I_QC, &
    I_QR_suzuki10 => I_QR, &
    I_QI_suzuki10 => I_QI, &
    I_QS_suzuki10 => I_QS, &
    I_QG_suzuki10 => I_QG, &
    I_NC_suzuki10 => I_NC, &
    I_NR_suzuki10 => I_NR, &
    I_NI_suzuki10 => I_NI, &
    I_NS_suzuki10 => I_NS, &
    I_NG_suzuki10 => I_NG, &
    QQA_suzuki10 => QQA, &
    QQS_suzuki10 => QQS, &
    QQE_suzuki10 => QQE, &
    QWS_suzuki10 => QWS, &
    QWE_suzuki10 => QWE, &
    QIS_suzuki10 => QIS, &
    QIE_suzuki10 => QIE, &
    MP_QA_suzuki10 => MP_QA, &
    AQ_MP_NAME_suzuki10 => AQ_MP_NAME, &
    AQ_MP_DESC_suzuki10 => AQ_MP_DESC, &
    AQ_MP_UNIT_suzuki10 => AQ_MP_UNIT, &
    I_MP2ALL_suzuki10 => I_MP2ALL, &
    I_MP2RD_suzuki10 => I_MP2RD, &
    TRACER_suzuki10_setup
  use scale_tracer_sdm, only: &
    QA_MP_sdm => QA_MP, &
    I_QV_sdm => I_QV, &
    I_QC_sdm => I_QC, &
    I_QR_sdm => I_QR, &
    I_QI_sdm => I_QI, &
    I_QS_sdm => I_QS, &
    I_QG_sdm => I_QG, &
    I_NC_sdm => I_NC, &
    I_NR_sdm => I_NR, &
    I_NI_sdm => I_NI, &
    I_NS_sdm => I_NS, &
    I_NG_sdm => I_NG, &
    QQA_sdm => QQA, &
    QQS_sdm => QQS, &
    QQE_sdm => QQE, &
    QWS_sdm => QWS, &
    QWE_sdm => QWE, &
    QIS_sdm => QIS, &
    QIE_sdm => QIE, &
    MP_QA_sdm => MP_QA, &
    AQ_MP_NAME_sdm => AQ_MP_NAME, &
    AQ_MP_DESC_sdm => AQ_MP_DESC, &
    AQ_MP_UNIT_sdm => AQ_MP_UNIT, &
    I_MP2ALL_sdm => I_MP2ALL, &
    I_MP2RD_sdm => I_MP2RD, &
    TRACER_sdm_setup
  use scale_aetracer_none, only: &
    QA_AE_none => QA_AE, &
    AE_CTG_none => AE_CTG, &
    N_ATR_none => N_ATR, &
    GAS_CTG_none => GAS_CTG, &
    NSIZ_none => NSIZ, &
    NKAP_none => NKAP, &
    IC_MIX_none => IC_MIX, &
    IC_SEA_none => IC_SEA, &
    IC_DUS_none => IC_DUS, &
    IG_H2SO4_none => IG_H2SO4, &
    IG_CGAS_none => IG_CGAS, &
    AE_QA_none => AE_QA, &
    I_ae_dummy_none => I_ae_dummy, &
    AQ_AE_NAME_none => AQ_AE_NAME, &
    AQ_AE_DESC_none => AQ_AE_DESC, &
    AQ_AE_UNIT_none => AQ_AE_UNIT, &
    I_AE2ALL_none => I_AE2ALL, &
    I_AE2RD_none => I_AE2RD, &
    AETRACER_none_setup
  use scale_aetracer_kajino13, only: &
    QA_AE_kajino13 => QA_AE, &
    AE_CTG_kajino13 => AE_CTG, &
    N_ATR_kajino13 => N_ATR, &
    GAS_CTG_kajino13 => GAS_CTG, &
    NSIZ_kajino13 => NSIZ, &
    NKAP_kajino13 => NKAP, &
    IC_MIX_kajino13 => IC_MIX, &
    IC_SEA_kajino13 => IC_SEA, &
    IC_DUS_kajino13 => IC_DUS, &
    IG_H2SO4_kajino13 => IG_H2SO4, &
    IG_CGAS_kajino13 => IG_CGAS, &
    AE_QA_kajino13 => AE_QA, &
    I_ae_dummy_kajino13 => I_ae_dummy, &
    AQ_AE_NAME_kajino13 => AQ_AE_NAME, &
    AQ_AE_DESC_kajino13 => AQ_AE_DESC, &
    AQ_AE_UNIT_kajino13 => AQ_AE_UNIT, &
    I_AE2ALL_kajino13 => I_AE2ALL, &
    I_AE2RD_kajino13 => I_AE2RD, &
    AETRACER_kajino13_setup
#endif
    implicit none
#ifndef TRACER
    namelist / PARAM_TRACER / &
         TRACER_TYPE, &
         AETRACER_TYPE
#endif

    integer :: ierr
    !---------------------------------------------------------------------------

    if( IO_L ) write(IO_FID_LOG,*) ''
    if( IO_L ) write(IO_FID_LOG,*) '+++ Module[TRACER]/Categ[COMMON]'

#ifdef TRACER
    call _SETUP(TRACER)
#else
    !--- read namelist
    rewind(IO_FID_CONF)
    read(IO_FID_CONF,nml=PARAM_TRACER,iostat=ierr)

    if( ierr < 0 ) then !--- missing
       if( IO_L ) write(IO_FID_LOG,*) '*** Not found namelist. Default used.'
    elseif( ierr > 0 ) then !--- fatal error
       write(*,*) 'xxx Not appropriate names in namelist PARAM_TRACER. Check!'
       call PRC_MPIstop
    endif
    if( IO_L ) write(IO_FID_LOG,nml=PARAM_TRACER)

    select case (TRACER_TYPE)
    case ("DRY")
       call TRACER_dry_setup
       QA_MP = QA_MP_dry
       I_QV = I_QV_dry
       I_QC = I_QC_dry
       I_QR = I_QR_dry
       I_QI = I_QI_dry
       I_QS = I_QS_dry
       I_QG = I_QG_dry
       I_NC = I_NC_dry
       I_NR = I_NR_dry
       I_NI = I_NI_dry
       I_NS = I_NS_dry
       I_NG = I_NG_dry
       QQA = QQA_dry
       QQS = QQS_dry
       QQE = QQE_dry
       QWS = QWS_dry
       QWE = QWE_dry
       QIS = QIS_dry
       QIE = QIE_dry
       MP_QA = MP_QA_dry
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_dry
       AQ_MP_DESC = AQ_MP_DESC_dry
       AQ_MP_UNIT = AQ_MP_UNIT_dry
       I_MP2ALL = I_MP2ALL_dry
       I_MP2RD = I_MP2RD_dry
    case ("KESSLER")
       call TRACER_kessler_setup
       QA_MP = QA_MP_kessler
       I_QV = I_QV_kessler
       I_QC = I_QC_kessler
       I_QR = I_QR_kessler
       I_QI = I_QI_kessler
       I_QS = I_QS_kessler
       I_QG = I_QG_kessler
       I_NC = I_NC_kessler
       I_NR = I_NR_kessler
       I_NI = I_NI_kessler
       I_NS = I_NS_kessler
       I_NG = I_NG_kessler
       QQA = QQA_kessler
       QQS = QQS_kessler
       QQE = QQE_kessler
       QWS = QWS_kessler
       QWE = QWE_kessler
       QIS = QIS_kessler
       QIE = QIE_kessler
       MP_QA = MP_QA_kessler
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_kessler
       AQ_MP_DESC = AQ_MP_DESC_kessler
       AQ_MP_UNIT = AQ_MP_UNIT_kessler
       I_MP2ALL = I_MP2ALL_kessler
       I_MP2RD = I_MP2RD_kessler
    case ("TOMITA08")
       call TRACER_tomita08_setup
       QA_MP = QA_MP_tomita08
       I_QV = I_QV_tomita08
       I_QC = I_QC_tomita08
       I_QR = I_QR_tomita08
       I_QI = I_QI_tomita08
       I_QS = I_QS_tomita08
       I_QG = I_QG_tomita08
       I_NC = I_NC_tomita08
       I_NR = I_NR_tomita08
       I_NI = I_NI_tomita08
       I_NS = I_NS_tomita08
       I_NG = I_NG_tomita08
       QQA = QQA_tomita08
       QQS = QQS_tomita08
       QQE = QQE_tomita08
       QWS = QWS_tomita08
       QWE = QWE_tomita08
       QIS = QIS_tomita08
       QIE = QIE_tomita08
       MP_QA = MP_QA_tomita08
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_tomita08
       AQ_MP_DESC = AQ_MP_DESC_tomita08
       AQ_MP_UNIT = AQ_MP_UNIT_tomita08
       I_MP2ALL = I_MP2ALL_tomita08
       I_MP2RD = I_MP2RD_tomita08
    case ("SN14")
       call TRACER_sn14_setup
       QA_MP = QA_MP_sn14
       I_QV = I_QV_sn14
       I_QC = I_QC_sn14
       I_QR = I_QR_sn14
       I_QI = I_QI_sn14
       I_QS = I_QS_sn14
       I_QG = I_QG_sn14
       I_NC = I_NC_sn14
       I_NR = I_NR_sn14
       I_NI = I_NI_sn14
       I_NS = I_NS_sn14
       I_NG = I_NG_sn14
       QQA = QQA_sn14
       QQS = QQS_sn14
       QQE = QQE_sn14
       QWS = QWS_sn14
       QWE = QWE_sn14
       QIS = QIS_sn14
       QIE = QIE_sn14
       MP_QA = MP_QA_sn14
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_sn14
       AQ_MP_DESC = AQ_MP_DESC_sn14
       AQ_MP_UNIT = AQ_MP_UNIT_sn14
       I_MP2ALL = I_MP2ALL_sn14
       I_MP2RD = I_MP2RD_sn14
    case ("SUZUKI10")
       call TRACER_suzuki10_setup
       QA_MP = QA_MP_suzuki10
       I_QV = I_QV_suzuki10
       I_QC = I_QC_suzuki10
       I_QR = I_QR_suzuki10
       I_QI = I_QI_suzuki10
       I_QS = I_QS_suzuki10
       I_QG = I_QG_suzuki10
       I_NC = I_NC_suzuki10
       I_NR = I_NR_suzuki10
       I_NI = I_NI_suzuki10
       I_NS = I_NS_suzuki10
       I_NG = I_NG_suzuki10
       QQA = QQA_suzuki10
       QQS = QQS_suzuki10
       QQE = QQE_suzuki10
       QWS = QWS_suzuki10
       QWE = QWE_suzuki10
       QIS = QIS_suzuki10
       QIE = QIE_suzuki10
       MP_QA = MP_QA_suzuki10
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_suzuki10
       AQ_MP_DESC = AQ_MP_DESC_suzuki10
       AQ_MP_UNIT = AQ_MP_UNIT_suzuki10
       I_MP2ALL = I_MP2ALL_suzuki10
       I_MP2RD = I_MP2RD_suzuki10
    case ("SDM")
       call TRACER_sdm_setup
       QA_MP = QA_MP_sdm
       I_QV = I_QV_sdm
       I_QC = I_QC_sdm
       I_QR = I_QR_sdm
       I_QI = I_QI_sdm
       I_QS = I_QS_sdm
       I_QG = I_QG_sdm
       I_NC = I_NC_sdm
       I_NR = I_NR_sdm
       I_NI = I_NI_sdm
       I_NS = I_NS_sdm
       I_NG = I_NG_sdm
       QQA = QQA_sdm
       QQS = QQS_sdm
       QQE = QQE_sdm
       QWS = QWS_sdm
       QWE = QWE_sdm
       QIS = QIS_sdm
       QIE = QIE_sdm
       MP_QA = MP_QA_sdm
       allocate( AQ_MP_NAME(QA_MP) )
       allocate( AQ_MP_DESC(QA_MP) )
       allocate( AQ_MP_UNIT(QA_MP) )
       allocate( I_MP2ALL(MP_QA) )
       allocate( I_MP2RD(MP_QA) )
       AQ_MP_NAME = AQ_MP_NAME_sdm
       AQ_MP_DESC = AQ_MP_DESC_sdm
       AQ_MP_UNIT = AQ_MP_UNIT_sdm
       I_MP2ALL = I_MP2ALL_sdm
       I_MP2RD = I_MP2RD_sdm
     case default
        write(*,*) 'xxx Unsupported TRACER_TYPE (', trim(TRACER_TYPE), '). Check!'
        call PRC_MPIstop
     end select
     select case (AETRACER_TYPE)
     case ("NONE")
       call AETRACER_none_setup
       QA_AE = QA_AE_none
       AE_CTG = AE_CTG_none
       N_ATR = N_ATR_none
       GAS_CTG = GAS_CTG_none
       allocate( NSIZ(AE_CTG) )
       allocate( NKAP(AE_CTG) )
       NSIZ = NSIZ_none
       NKAP = NKAP_none
       IC_MIX = IC_MIX_none
       IC_SEA = IC_SEA_none
       IC_DUS = IC_DUS_none
       IG_H2SO4 = IG_H2SO4_none
       IG_CGAS = IG_CGAS_none
       AE_QA = AE_QA_none
       I_ae_dummy = I_ae_dummy_none
       allocate( AQ_AE_NAME(QA_AE) )
       allocate( AQ_AE_DESC(QA_AE) )
       allocate( AQ_AE_UNIT(QA_AE) )
       allocate( I_AE2ALL(AE_QA) )
       allocate( I_AE2RD(AE_QA) )
       AQ_AE_NAME = AQ_AE_NAME_none
       AQ_AE_DESC = AQ_AE_DESC_none
       AQ_AE_UNIT = AQ_AE_UNIT_none
       I_AE2ALL = I_AE2ALL_none
       I_AE2RD = I_AE2RD_none
     case ("KAJINO13")
       call AETRACER_kajino13_setup
       QA_AE = QA_AE_kajino13
       AE_CTG = AE_CTG_kajino13
       N_ATR = N_ATR_kajino13
       GAS_CTG = GAS_CTG_kajino13
       allocate( NSIZ(AE_CTG) )
       allocate( NKAP(AE_CTG) )
       NSIZ = NSIZ_kajino13
       NKAP = NKAP_kajino13
       IC_MIX = IC_MIX_kajino13
       IC_SEA = IC_SEA_kajino13
       IC_DUS = IC_DUS_kajino13
       IG_H2SO4 = IG_H2SO4_kajino13
       IG_CGAS = IG_CGAS_kajino13
       AE_QA = AE_QA_kajino13
       I_ae_dummy = I_ae_dummy_kajino13
       allocate( AQ_AE_NAME(QA_AE) )
       allocate( AQ_AE_DESC(QA_AE) )
       allocate( AQ_AE_UNIT(QA_AE) )
       allocate( I_AE2ALL(AE_QA) )
       allocate( I_AE2RD(AE_QA) )
       AQ_AE_NAME = AQ_AE_NAME_kajino13
       AQ_AE_DESC = AQ_AE_DESC_kajino13
       AQ_AE_UNIT = AQ_AE_UNIT_kajino13
       I_AE2ALL = I_AE2ALL_kajino13
       I_AE2RD = I_AE2RD_kajino13
     case default
        write(*,*) 'xxx Unsupported AETRACER_TYPE (', trim(AETRACER_TYPE), '). Check!'
        call PRC_MPIstop
     end select
     QAES = QA_MP+1
     QAEE = QA_MP+QA_AE
     QA = QA_MP + QA_AE
     allocate( AQ_NAME(QA) )
     allocate( AQ_DESC(QA) )
     allocate( AQ_UNIT(QA) )
     AQ_NAME(1:QA_MP) = AQ_MP_NAME(1:QA_MP)
     AQ_DESC(1:QA_MP) = AQ_MP_DESC(1:QA_MP)
     AQ_UNIT(1:QA_MP) = AQ_MP_UNIT(1:QA_MP)
     AQ_NAME(QA_MP+1:QA_MP+QA_AE) = AQ_AE_NAME(1:QA_AE)
     AQ_DESC(QA_MP+1:QA_MP+QA_AE) = AQ_AE_DESC(1:QA_AE)
     AQ_UNIT(QA_MP+1:QA_MP+QA_AE) = AQ_AE_UNIT(1:QA_AE)
#endif

  end subroutine TRACER_setup

end module scale_tracer
